﻿using Syncfusion.XlsIO;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Expressions;
using Syncfusion.Linq;
using System.Reflection;
using System.Web;
using System.Web.Script.Serialization;
using Syncfusion.EJ.Export;
using System.Dynamic;
using System.Text.RegularExpressions;
using System.ComponentModel;
using System.Globalization;
using System.Drawing;
using Syncfusion.JavaScript.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Web.Mvc;

//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Web;
//using System.Web.Mvc;
//using MvcApplication12;
//using Syncfusion.EJ.Export;
//using Syncfusion.JavaScript.Models;
//using Syncfusion.XlsIO;
//using System.Web.Script.Serialization;
//using System.Collections;
//using System.Reflection;

//using System.Web.HttpContext;
//using System.Collections;

//using System.Data;
//using System.Linq;
//using System.Linq.Expressions;

namespace MvcApplication12.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            var DataSource = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.datasource = DataSource;
            return View();
        }
        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            ExcelEngine excel = new ExcelEngine();
            IApplication application = excel.Excel;
            var DataSource = new NorthwindDataContext().OrdersViews.ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            IWorkbook workbook = application.Workbooks.Create(2);
            //Setting multiExport as true and export the document and assigned to workbook
            workbook = exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "default-theme",true);
            //Inserted new row for adding title
            workbook.ActiveSheet.InsertRow(1);
            //Merging the sheet from Range A1 to D1 for adding title space
            workbook.ActiveSheet.Range["A1:D1"].Merge();
            //Adding the title using Text property
            workbook.ActiveSheet.Range["A1"].Text = "Methodologies for the Typical Unification of Access Points and Redundancy";
            //Adding the footer information using SetValue method of the ActiveSheet
            workbook.ActiveSheet.SetValue(workbook.ActiveSheet.Rows.Length + 2, workbook.ActiveSheet.Columns.Length - 3, "This report is for the Deputy Senior VP in charge of things that don't really matter. If this is not you, please destroy and notify the intended recipient immediately"); 
            //Downloading the document
            workbook.SaveAs("Export.xls", HttpContext.ApplicationInstance.Response,ExcelDownloadType.PromptDialog, ExcelHttpContentType.Excel2010);
          
        }
       
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

    }
}
